#!/bin/bash
version=$(rpm -qa \*-release | grep -Ei "oracle|redhat|centos|cloudlinux" | cut -d"." -f1 | cut -d"-" -f3)
rm -rf /usr/local/src/build

#Create logs for new php
[[ -d "/usr/local/var/log/" ]] || mkdir -p /usr/local/var/log/ 
[[ -f "/usr/local/var/log/php-fpm.log" ]] || touch /usr/local/var/log/php-fpm.log

#Instal Pre-Requistes
yum clean all
yum repolist
yum groupinstall "Development tools" -y 
yum -y install cagefs lvemanager patch liblve-devel systemd-devel 
/usr/sbin/cagefsctl --init 
cagefsctl --enable-all

#install prerequisites
yum install -y libcurl-devel alt-ruby21 alt-ruby21-devel alt-ruby21-rubygem-rake alt-ruby21-rubygem-rack alt-python27 alt-python27-cllib gcc-c++ which cmake python-criu-lve criu-lve-devel crit-lve criu-lve alt-python27-raven python python-lxml liblsapi liblsapi-devel
yum install -y alt-ruby21-rubygem-rack alt-python27 alt-python27-cllib gcc-c++ which cmake python-criu-lve criu-lve-devel crit-lve criu-lve alt-python27-raven python python-lxml liblsapi liblsapi-devel
yum install -y libcurl-devel alt-ruby21 alt-ruby21-devel alt-ruby21-rubygem-rake alt-ruby21-rubygem-rack alt-python27 alt-python27-cllib gcc-c++ which cmake python-criu-lve criu-lve-devel crit-lve criu-lve alt-python27-raven python python-lxml liblsapi liblsapi-devel

#Install modules
rpm -ivh http://dl1.centos-webpanel.com/files/3rdparty/cloudlinux/mod_hostinglimits-1.0-36.el7.cloudlinux.x86_64.rpm 
rpm -ivh http://dl1.centos-webpanel.com/files/3rdparty/cloudlinux/alt-mod-passenger-5.3.7-4.el7.cloudlinux.x86_64.rpm
rpm -ivh http://dl1.centos-webpanel.com/files/3rdparty/cloudlinux/mod_lsapi-1.1-43.el7.cloudlinux.x86_64.rpm

#Add logs to mod_lsapi
echo "/usr/local/apache/logs/sulsphp_log" >> /usr/local/apache/conf.d/lsapi.conf

#Install patched php-fpm
[ -d "/usr/local/src/build" ] || mkdir -p /usr/local/src/build 
cd /usr/local/src/build || exit 
declare -A version 
version=( [0]=5.3.29 [1]=5.4.45 [2]=5.5.38 [3]=5.6.40 [4]=7.0.33 [5]=7.1.33 [6]=7.2.29 [7]=7.3.16 ) 
wget http://dl1.centos-webpanel.com/files/php/php-"${version[0]}".tar.gz 
wget http://dl1.centos-webpanel.com/files/php/php-"${version[1]}".tar.gz 
wget http://dl1.centos-webpanel.com/files/php/php-"${version[2]}".tar.gz 
wget http://dl1.centos-webpanel.com/files/php/php-"${version[3]}".tar.gz 
wget http://dl1.centos-webpanel.com/files/php/php-"${version[4]}".tar.gz 
wget http://dl1.centos-webpanel.com/files/php/php-"${version[5]}".tar.gz 
wget http://dl1.centos-webpanel.com/files/php/php-"${version[6]}".tar.gz 
wget http://dl1.centos-webpanel.com/files/php/php-"${version[7]}".tar.gz

#Download patches and extract
wget http://repo.cloudlinux.com/cloudlinux/sources/da/cl-apache-patches.tar.gz 
tar -zxvf cl-apache-patches.tar.gz

nproc_check(){
if [ -e "/usr/bin/nproc" ];then
        make -j "$(/usr/bin/nproc)" 2>&1
else
        make 2>&1
fi
}
#Build Php-fpm php 5.3
#cd /usr/local/src/build || exit 
#tar -xzf php-"${version[0]}".tar.gz 
#cd php-"${version[0]}" || exit 
#patch -p1 < /usr/local/src/build/fpm-lve-php5.3.3.patch 
#autoconf 
#./configure --enable-fpm --with-fpm-systemd 
#nproc_check

#php 5.4
tar -xzf php-"${version[1]}".tar.gz 
cd php-"${version[1]}" || exit 
patch -p1 < /usr/local/src/build/fpm-lve-php5.4.patch 
autoconf 
./configure --enable-fpm --with-fpm-systemd 
nproc_check

#php 5.5
cd /usr/local/src/build || exit
tar -xvzf php-"${version[2]}".tar.gz 
cd php-"${version[2]}" || exit 
patch -p1 < /usr/local/src/build/fpm-lve-php5.5_autoconf.patch 
autoconf 
./configure --enable-fpm --with-fpm-systemd 
nproc_check

#php 5.6
cd /usr/local/src/build || exit
tar -xvzf php-"${version[3]}".tar.gz 
cd php-"${version[3]}" || exit 
patch -p1 < /usr/local/src/build/fpm-lve-php5.6_autoconf.patch 
autoconf 
./configure --enable-fpm --with-fpm-systemd 
nproc_check

#php 7.0
cd /usr/local/src/build || exit
tar -xvzf php-"${version[4]}".tar.gz 
cd php-"${version[4]}" || exit 
patch -p1 < /usr/local/src/build/fpm-lve-php7.0_autoconf.dl.v2.patch.patch 
autoconf 
./configure --enable-fpm --with-fpm-systemd 
nproc_check

#php 7.1
cd /usr/local/src/build || exit
tar -xvzf php-"${version[5]}".tar.gz 
cd php-"${version[5]}" || exit 
patch -p1 < /usr/local/src/build/php-fpm.7.1.dl.v3.patch 
autoconf 
./configure --enable-fpm --with-fpm-systemd 
nproc_check

#php 7.2
cd /usr/local/src/build || exit
tar -xvzf php-"${version[6]}".tar.gz 
cd php-"${version[6]}" || exit 
patch -p1 < /usr/local/src/build/php-fpm.7.2.dl.v2.patch 
autoconf 
./configure --enable-fpm --with-fpm-systemd 
nproc_check

#php 7.2
cd /usr/local/src/build || exit
tar -xvzf php-"${version[7]}".tar.gz 
cd php-"${version[7]}" || exit 
patch -p1 < /usr/local/src/build/php-fpm.7.2.dl.v2.patch 
autoconf 
./configure --enable-fpm --with-fpm-systemd 
nproc_check

#Rename and restart php-fpm
declare -A version2 
version2=( [0]=53 [1]=54 [2]=55 [3]=56 [4]=70 [5]=71 [6]=72 [7]=73 )

#Use new php-fpm frm make
#php 5.3
#if [ -f /opt/alt/php-fpm"${version2[0]}"/usr/sbin/php-fpm ]; then
#        mv /opt/alt/php-fpm"${version2[0]}"/usr/sbin/php-fpm /opt/alt/php-fpm"${version2[0]}"/usr/sbin/php-fpm.old
#        cp /usr/local/src/build/php-"${version[0]}"/sapi/fpm/php-fpm /opt/alt/php-fpm"${version2[0]}"/usr/sbin
#        systemctl restart php-fpm"${version2[0]}" 
#else
#        echo "PHP 5.3 is not installed,Please install if you have application that uses it"
#        exit 0 
#fi

#php 5.4
if [ -f /opt/alt/php-fpm"${version2[1]}"/usr/sbin/php-fpm ]; then
        mv /opt/alt/php-fpm"${version2[1]}"/usr/sbin/php-fpm /opt/alt/php-fpm"${version2[1]}"/usr/sbin/php-fpm.old
        cp /usr/local/src/build/php-"${version[1]}"/sapi/fpm/php-fpm /opt/alt/php-fpm"${version2[1]}"/usr/sbin
        systemctl restart php-fpm"${version2[1]}" 
else
        echo "PHP 5.4 is not installed,Please install if you have application that uses it"
        exit 0 
fi

#php 5.5
if [ -f /opt/alt/php-fpm"${version2[2]}"/usr/sbin/php-fpm ]; then
        mv /opt/alt/php-fpm"${version2[2]}"/usr/sbin/php-fpm /opt/alt/php-fpm"${version2[2]}"/usr/sbin/php-fpm.old
        cp /usr/local/src/build/php-"${version[2]}"/sapi/fpm/php-fpm /opt/alt/php-fpm"${version2[2]}"/usr/sbin
        systemctl restart php-fpm"${version2[2]}" 
else
        echo "PHP 5.5 is not installed,Please install if you have application that uses it"
        exit 0 
fi

#php 5.6
if [ -f /opt/alt/php-fpm"${version2[3]}"/usr/sbin/php-fpm ]; then
        mv /opt/alt/php-fpm"${version2[3]}"/usr/sbin/php-fpm /opt/alt/php-fpm"${version2[3]}"/usr/sbin/php-fpm.old
        cp /usr/local/src/build/php-"${version[3]}"/sapi/fpm/php-fpm /opt/alt/php-fpm"${version2[3]}"/usr/sbin
        systemctl restart php-fpm"${version2[3]}" 
else
        echo "PHP 5.6 is not installed,Please install if you have application that uses it"
        exit 0 
fi

#php 7.0
if [ -f /opt/alt/php-fpm"${version2[4]}"/usr/sbin/php-fpm ]; then
        mv /opt/alt/php-fpm"${version2[4]}"/usr/sbin/php-fpm /opt/alt/php-fpm"${version2[4]}"/usr/sbin/php-fpm.old
        cp /usr/local/src/build/php-"${version[4]}"/sapi/fpm/php-fpm /opt/alt/php-fpm"${version2[4]}"/usr/sbin
        systemctl restart php-fpm"${version2[4]}" 
else
        echo "PHP 7.0 is not installed,Please install if you have application that uses it"
        exit 0 
fi

#php 7.1
if [ -f /opt/alt/php-fpm"${version2[5]}"/usr/sbin/php-fpm ]; then
        mv /opt/alt/php-fpm"${version2[5]}"/usr/sbin/php-fpm /opt/alt/php-fpm"${version2[5]}"/usr/sbin/php-fpm.old
        cp /usr/local/src/build/php-"${version[5]}"/sapi/fpm/php-fpm /opt/alt/php-fpm"${version2[5]}"/usr/sbin
        systemctl restart php-fpm"${version2[5]}" 
else
        echo "PHP 7.1 is not installed,Please install if you have application that uses it"
        exit 0 
fi

#php 7.2
if [ -f /opt/alt/php-fpm"${version2[6]}"/usr/sbin/php-fpm ]; then
        mv /opt/alt/php-fpm"${version2[6]}"/usr/sbin/php-fpm /opt/alt/php-fpm"${version2[6]}"/usr/sbin/php-fpm.old
        cp /usr/local/src/build/php-"${version[6]}"/sapi/fpm/php-fpm /opt/alt/php-fpm"${version2[6]}"/usr/sbin
        systemctl restart php-fpm"${version2[6]}" 
else
        echo "PHP 7.2 is not installed,Please install if you have application that uses it"
        exit 0 
fi

#php 7.3
if [ -f /opt/alt/php-fpm"${version2[7]}"/usr/sbin/php-fpm ]; then
        mv /opt/alt/php-fpm"${version2[7]}"/usr/sbin/php-fpm /opt/alt/php-fpm"${version2[7]}"/usr/sbin/php-fpm.old
        cp /usr/local/src/build/php-"${version[7]}"/sapi/fpm/php-fpm /opt/alt/php-fpm"${version2[7]}"/usr/sbin
        systemctl restart php-fpm"${version2[7]}" 
else
        echo "PHP 7.3 is not installed,Please install if you have application that uses it"
        exit 0 
fi 

#remove Build folder
rm -rf /usr/local/src/build

RETVAL=$?
if [ $RETVAL -eq "0" ];then
	echo "" 
	echo "CloudLinux modules integrated successfully with CWP" 
	echo "" 
	echo "Reboot server with the command shutdown -r now"
	echo ""
else
	echo "Integration failed, Please review errors and try again"
fi
